Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

// 3rd-party modules

var _webPockets = require('web-pockets');

var _webPockets2 = _interopRequireDefault(_webPockets);

var AbstractServer = (function () {
  function AbstractServer(options) {
    _classCallCheck(this, AbstractServer);

    this.app = (0, _webPockets2['default'])();
    this.options = options || {};

    this.injectLogging();
    this.bindRoutes();
  }

  _createClass(AbstractServer, [{
    key: 'listen',
    value: function listen(port, iface, callback) {
      this.httpServer = this.app.listen(port, iface, callback);
      return this.httpServer;
    }
  }, {
    key: 'close',
    value: function close(callback) {
      if (this.httpServer) {
        this.httpServer.close(callback);
      }
    }
  }, {
    key: 'injectLogging',
    value: function injectLogging() {
      var _this = this;

      function getStatusCode(result) {
        if (result.body && result.body.responseStatus !== result.statusCode) {
          return result.body.responseStatus;
        } else {
          return result.statusCode;
        }
      }

      this.app.request.wrap('result', function (result, request) {
        var start = new Date();

        return result().then(function (result) {
          if (!_this.options.disableLogging) {
            console[result.statusCode < 500 ? 'log' : 'error']({
              url: request.url,
              host: request.headers.host,
              success: result.statusCode < 400,
              tags: ['result'],
              statusCode: getStatusCode(result),
              responseDetails: result.body.responseDetails,
              duration: new Date() - start
            });
          }

          return result;
        });
      });
    }
  }, {
    key: 'bindRoutes',
    value: function bindRoutes() {
      throw new Error('Overwrite bindRoutes!');
    }
  }]);

  return AbstractServer;
})();

exports['default'] = AbstractServer;
module.exports = exports['default'];