Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

// 3rd-party modules

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fastFeed = require('fast-feed');

var _fastFeed2 = _interopRequireDefault(_fastFeed);

// Local modules

var _helper = require('./helper');

var Feed = (function () {
  function Feed(url) {
    _classCallCheck(this, Feed);

    this.url = url;
  }

  _createClass(Feed, [{
    key: 'read',
    value: function read(options) {
      var _this = this;

      options = _lodash2['default'].extend({
        num: 4
      }, options);

      return (0, _helper.getResource)(this.url).then(function (res) {
        return new Promise(function (resolve, reject) {
          _fastFeed2['default'].parse(res.data, { extensions: true }, function (err, feed) {
            if (err) {
              return reject(err);
            } else {
              return resolve(feed);
            }
          });
        });
      }).then(function (feed) {
        return _this._format(feed);
      }).then(function (feed) {
        return _this._applyOptions(feed, options);
      });
    }
  }, {
    key: '_format',
    value: function _format(data) {
      var _this2 = this;

      var author = data.author || '';

      return {
        feedUrl: this.url,
        title: data.title,
        link: data.link,
        description: data.subtitle || data.description || '',
        author: author,
        entries: data.items.map(function (item) {
          return _this2._formatItem(author, item);
        })
      };
    }
  }, {
    key: '_applyOptions',
    value: function _applyOptions(feed, options) {
      feed.entries = feed.entries.slice(0, options.num);

      return feed;
    }
  }, {
    key: '_formatItem',
    value: function _formatItem(author, item) {
      var content = item.content || item.summary || item.description || '';

      content = content.replace(/\u2028/g, '').replace(/\u2029/g, '');

      return {
        title: item.title,
        link: item.link,
        content: content,
        contentSnippet: content.replace(/(<([^>]+)>)/ig, '').substring(0, 120),
        publishedDate: item.published || item.pubDate || item.date,
        categories: [],
        author: item.author || this._extractCreator(item) || author
      };
    }
  }, {
    key: '_extractCreator',
    value: function _extractCreator(item) {
      if (item.extensions) {
        var extension = item.extensions.find(function (extension) {
          return extension.name === 'dc:creator';
        });

        return (extension || {}).value;
      }
    }
  }]);

  return Feed;
})();

exports['default'] = Feed;
module.exports = exports['default'];