Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.getResource = getResource;
exports.badRequest = badRequest;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

// 3rd-party modules

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

function getResource(url) {
  return _axios2['default'].get(url)['catch'](function (err) {
    if (_lodash2['default'].includes([301, 302], err.status)) {
      return getResource(err.headers.location);
    } else {
      throw err;
    }
  });
}

function badRequest(details) {
  return {
    responseStatus: 400,
    responseDetails: details,
    responseData: { feed: null }
  };
}