Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// 3rd-party modules

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

// Local modules

var _abstractServer = require('./abstract-server');

var _abstractServer2 = _interopRequireDefault(_abstractServer);

var _feed = require('./feed');

var _feed2 = _interopRequireDefault(_feed);

var _helper = require('./helper');

var Server = (function (_AbstractServer) {
  _inherits(Server, _AbstractServer);

  function Server() {
    _classCallCheck(this, Server);

    _get(Object.getPrototypeOf(Server.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Server, [{
    key: 'bindRoutes',
    value: function bindRoutes() {
      this.app.request.value('feedUrl', function (queryParams) {
        return queryParams.q;
      });

      this.app.request.value('feedOptions', function (queryParams) {
        return _lodash2['default'].pick(queryParams, 'num');
      });

      this.app.request.value('feed', function (feedOptions, feedUrl) {
        if (feedUrl) {
          return new _feed2['default'](feedUrl).read(feedOptions).then(function (feed) {
            return { responseStatus: 200, responseDetails: null, responseData: { feed: feed } };
          })['catch'](function (e) {
            console.error(e);
            return (0, _helper.badRequest)({ message: 'Parsing the provided feed url failed.' });
          });
        } else {
          return (0, _helper.badRequest)({
            message: 'No q param found!',
            details: 'Please add a query parameter "q" to the request URL which points to a feed!'
          });
        }
      });

      this.app.route('GET *', function (queryParams, feed) {
        if (queryParams.callback) {
          return {
            headers: {
              'content-type': 'text/javascript; charset=utf-8'
            },
            body: queryParams.callback + '(' + JSON.stringify(feed) + ');'
          };
        } else {
          return feed;
        }
      });
    }
  }]);

  return Server;
})(_abstractServer2['default']);

exports['default'] = Server;
module.exports = exports['default'];